<script setup lang="ts">
import material from '@/services/material';
import { useMaterialStore } from '@/stores/material';
import type { Material } from '@/types/Material';
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const headers = [
  { title: 'Id', key: 'id' },
  {
    title: 'DateUpdate',
    key: 'updated',
  },
  { title: 'Name', key: 'name' },
  { title: 'Max Quantity', key: 'qMax' },
  { title: 'Min Quantity', key: 'qMin' },
  { title: 'Quantity', key: 'quantity' },
  { key: 'actions', sortable: false },
]


const matrialStore = useMaterialStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const dialogPrint = ref(false)
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    matrialStore.clearForm()
  })
}

async function deleteItemConfirm() {
  // Delete item from list
  await matrialStore.deleteMaterial()
  closeDelete()
}
async function editItem(item: Material) {
  if (!item.id) return
  await matrialStore.getMaterial(item.id)
  dialog.value = true
}
async function deleteItem(item: Material) {
  if (!item.id) return
  await matrialStore.getMaterial(item.id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    matrialStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await matrialStore.saveMaterial()
  closeDialog()
}


onMounted(async () => {
  await matrialStore.getMaterials()
})


</script>
<template>
  <div>
    <v-data-table style="background-color: #efe7e1" :headers="headers" :items="matrialStore.materials">
      <template v-slot:top>
        <v-toolbar flat style="color: #f5f3ef; background-color: #8b7565">
          <v-toolbar-title>Stock Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog-->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn style="color: #0043c7; background-color: #f9f8f5" class="custom-button" v-bind="props"
                prepend-icon="mdi-plus">
                New Material
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Material</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-text-field v-model="matrialStore.editedMaterial.name" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Name"></v-text-field></v-col>
                      <v-col cols="12" sm="6"><v-text-field v-model="matrialStore.editedMaterial.quantity"
                          :readonly="loading" :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Quantity" type="number"></v-text-field></v-col>
                      <v-col cols="12" sm="6"><v-text-field v-model="matrialStore.editedMaterial.qMax"
                          :readonly="loading" :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Max Quantity" type="number"></v-text-field></v-col>
                      <v-col cols="12" sm="6"><v-text-field v-model="matrialStore.editedMaterial.qMin"
                          :readonly="loading" :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Min Quantity" type="number"></v-text-field></v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>


          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>

        </v-toolbar></template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="#81322c" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="#81322c" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="matrialStore.getMaterials"> Reset </v-btn>
      </template></v-data-table>
  </div>

  <!-- -Low Material-
  <v-dialog v-model="dialogPrint">
    <template> สินค้าใกล้หมดStock </template>
    <template>
      <v-data-table-virtual :headers="headers" height="400" item-value="name"></v-data-table-virtual>
    </template>
    <v-card class="mx-auto" width="800" prepend-icon="mdi-cart-outline">
      <template v-slot:title> สินค้าใกล้หมด Stock </template>
      <v-table>
        <thead>
          <tr>
            <th>Id</th>
            <th>Name</th>
            <th>Max Quantity</th>
            <th>Min Quantity</th>
            <th>Quantity</th>
            <th>Amount to Purchase</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item: " :key="item.id">
            <td>{{ item.id }}</td>
            <td>{{ item.name }}</td>
            <td>{{ item.qMax }}</td>
            <td>{{ item.qMin }}</td>
            <td>{{ item.quantity }}</td>
            <td>{{ item.qMax! - item.quantity! }}</td>
          </tr>
        </tbody>
      </v-table>
    </v-card>
  </v-dialog> -->
</template>
